Bug 1276112 - glibc: malloc arena free list can become cyclic
Summary: glibc: malloc arena free list can become cyclic
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: glibc
Version: 22
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: Florian Weimer
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks: 1279673
TreeView+ depends on / blocked
 
Reported: 2015-10-28 18:33 UTC by Florian Weimer
Modified: 2016-02-17 12:50 UTC (History)
8 users (show)

Fixed In Version: glibc-2.21-11.fc22
Doc Type: Bug Fix
Doc Text:
Clone Of:
: 1279673 (view as bug list)
Environment:
Last Closed: 2016-02-17 12:50:01 UTC


Attachments (Terms of Use)


Links
System ID Priority Status Summary Last Updated
Sourceware 19048 None None None Never

Description Florian Weimer 2015-10-28 18:33:55 UTC
malloc maintains a linked list of arenas which were used by threads at the time they exited.  New threads receive arenas from this list, in the expectation that they are unused and uncontended.  However, due to an incorrect assumption (one arena can be attached to several threads), the free list could turn cyclic.  If this happens, a potentially small set of arenas will be assigned to all new threads.

This bug is not a correctness issue, but it can significantly reduce application performance.  qemu-kvm and OpenJDK have been observed to trigger this bug.

Comment 1 Florian Weimer 2015-10-28 20:46:24 UTC
Patch posted for review:

  https://lists.fedoraproject.org/pipermail/glibc/2015-October/000090.html

Comment 3 Fedora Update System 2016-02-08 15:54:01 UTC
glibc-2.21-10.fc22 has been submitted as an update to Fedora 22. https://bodhi.fedoraproject.org/updates/FEDORA-2016-0480defc94

Comment 4 Fedora Update System 2016-02-10 11:55:02 UTC
glibc-2.21-10.fc22 has been pushed to the Fedora 22 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2016-0480defc94

Comment 5 Fedora Update System 2016-02-16 16:10:15 UTC
glibc-2.21-11.fc22 has been submitted as an update to Fedora 22. https://bodhi.fedoraproject.org/updates/FEDORA-2016-0480defc94

Comment 6 Fedora Update System 2016-02-17 06:27:58 UTC
glibc-2.21-11.fc22 has been pushed to the Fedora 22 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2016-0480defc94

Comment 7 Fedora Update System 2016-02-17 12:49:12 UTC
glibc-2.21-11.fc22 has been pushed to the Fedora 22 stable repository. If problems still persist, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.